%bcond_without repolib

Name:           cal10n
Version:        0.7.3
Release:        3%{?dist}
Epoch:          0
Summary:        Compiler assisted localization library (CAL10N)
Group:          Development/Libraries
License:        MIT
URL:            http://cal10n.qos.ch/
Source0:        http://cal10n.qos.ch/dist/cal10n-%{version}.tar.gz
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  commons-parent >= 0:9
BuildRequires:  junit4
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  maven2
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven2-plugin-site
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  vman
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Compiler Assisted Localization, abbreviated as CAL10N (pronounced as "calion") 
is a java library for writing localized (internationalized) messages.
Features:
    * java compiler verifies message keys used in source code
    * tooling to detect errors in message keys
    * native2ascii tool made superfluous, as you can directly encode bundles 
      in the most convenient charset, per locale.
    * good performance (300 nanoseconds per key look-up)
    * automatic reloading of resource bundles upon change

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
API documentation for %{name}.

%package -n maven-cal10n-plugin
Summary:    CAL10N maven plugin
Group:      Development/Tools
Requires:   maven2
Requires:   %{name} = %{epoch}:%{version}-%{release}

%description -n maven-cal10n-plugin
Maven plugin verifying that the codes defined in
an enum type match those in the corresponding resource bundles. 

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
find -type f -name "*.jar" | xargs -t rm

%build
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
# FIXME: cal10n-api/src/test/java/ch/qos/cal10n/util/MiscUtilTest.java:51 throws NPE
%{_bindir}/mvn-jpp -e -X -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} -Dmaven.test.failure.ignore deploy javadoc:aggregate

%install
rm -rf %{buildroot}

# jars
install -d -m 0755 %{buildroot}%{_javadir}/%{name}
install -p -m 644 cal10n-api/target/cal10n-api-%{version}.jar %{buildroot}%{_javadir}/%{name}/cal10n-api-%{version}.jar
install -p -m 644 maven-cal10n-plugin/target/maven-cal10n-plugin-%{version}.jar %{buildroot}%{_javadir}/%{name}/maven-cal10n-plugin-%{version}.jar
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; do ln -s ${jar} ${jar/-%{version}/}; done)

# poms
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -pm 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-parent.pom
install -pm 644 cal10n-api/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-%{name}-api.pom
install -pm 644 maven-cal10n-plugin/pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-maven-cal10n-plugin.pom

# depmaps
%add_to_maven_depmap ch.qos.cal10n cal10n-parent %{version} JPP/%{name} cal10n-parent
%add_to_maven_depmap ch.qos.cal10n cal10n-api %{version} JPP/%{name} cal10n-api
%add_to_maven_depmap ch.qos.cal10n maven-cal10n-plugin %{version} JPP/%{name} maven-cal10n-plugin

# javadoc
install -d -m 0755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/api*/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*/%{name}
%exclude %dir %{_javadocdir}/%{name}
%{_javadir}*/%{name}/cal10n-api.jar
%{_javadir}*/%{name}/cal10n-api-%{version}.jar
%{_datadir}/maven2/poms/JPP.%{name}-%{name}-parent.pom
%{_datadir}/maven2/poms/JPP.%{name}-%{name}-api.pom
%{_mavendepmapfragdir}/%{name}

%files -n maven-cal10n-plugin
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/maven-cal10n-plugin-%{version}.jar
%{_javadir}*/%{name}/maven-cal10n-plugin.jar
%{_datadir}/maven2/poms/JPP.%{name}-maven-cal10n-plugin.pom

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Aug 25 2011 David Walluck <dwalluck@redhat.com> 0:0.7.3-3
- Build for werewolf

* Thu Jul 07 2011 David Walluck <dwalluck@redhat.com> 0:0.7.3-2
- remove patch
- fix file list
- fix maven build

* Fri Dec 17 2010 David Walluck <dwalluck@redhat.com> 0:0.7.3-1
- 0.7.3
- fix maven-cal10n-plugin Requires
